<template>
	<view class="content">
		<view class="top-bg"></view>
		<view class="yue-wrap flex">
			<view class="yue-tit flex">
				<view class="yue-left">总资产(CNY)</view>
				<!-- <view class="tx"
					v-if="userInfo.phone == '13676659288' || userInfo.phone == '13738601238' || userInfo.phone == '18258668700' "
					@click="navto('/pages/money/wallet')">
					<image src="../../static/icon/hz.png" mode="widthFix"></image>
					消费积分互转
				</view> -->
			</view>
			<view class="yue-num flex">
				<view class="yue">{{ userInfo.now_money || '0.00' }}</view>
				<view class="">
					<!-- <view class="cz" @click="navto('/pages/money/recharge')">
						充值
						<image src="../../static/icon/dz.png" mode="widthFix"></image>
					</view> -->

				</view>
			</view>
			<view class="lj-wrap flex">
				<view class="">累计消费：￥{{ userInfo.orderStatusSum || '0' }}</view>
				<view class="">累计充值：￥{{ userInfo.recharge || '0' }}</view>
			</view>
		</view>
		<view class="navbar">
			<view v-for="(item, index) in navList" :key="index" class="nav-item"
				:class="{ current: tabCurrentIndex === index }" @click="tabClick(index)">{{ item.text }}</view>
		</view>
		<swiper :current="tabCurrentIndex" :style="{ height: maxheight }" class="swiper-box" duration="300"
			@change="changeTab">
			<swiper-item class="tab-content" v-for="(tabItem, tabIndex) in navList" :key="tabIndex">
				<scroll-view scroll-y="true" class="list-scroll-content" @scrolltolower="loadData">
					<!-- 空白页 -->
					<empty v-if="tabItem.loaded === true && tabItem.orderList.length === 0"></empty>

					<!-- 订单列表 -->
					<view>
						<view class="order-item flex" v-for="(item, index) in tabItem.orderList" :key="index">
							<view class="title-box">
								<view class="title">
									<text>{{ item.mark }}</text>
								</view>
								<view class="time">
									<text>{{ item.add_time }}</text>
								</view>
							</view>
							<view class="money">
								<view>{{ (item.pm == 0 ? '-' : '+') + item.number }}</view>
							</view>
						</view>
					</view>
					<uni-load-more :status="tabItem.loadingType"
						v-if="!(tabItem.orderList.length == 0 && tabItem.loaded)"></uni-load-more>
				</scroll-view>
			</swiper-item>
		</swiper>
	</view>
</template>

<script>
	import {
		mapState,
		mapMutations
	} from 'vuex';
	import {
		integral,
		userBalance
	} from '@/api/wallet.js';
	import {
		getMoneyStyle
	} from '@/utils/rocessor.js';
	import {
		getUserInfo,
	} from '@/api/user.js';
	import uniLoadMore from '@/components/uni-load-more/uni-load-more.vue';
	import empty from '@/components/empty';
	export default {
		filters: {
			getMoneyStyle
		},
		components: {
			empty,
			uniLoadMore
		},
		onReady() {
			// 初始化获取页面宽度
			var obj = this;
			uni.getSystemInfo({
				success: resu => {
					const query = uni.createSelectorQuery();
					query.select('.swiper-box').boundingClientRect();
					query.exec(function(res) {
						obj.maxheight = resu.windowHeight - res[0].top + 'px';
					});
				},
				fail: res => {}
			});
		},
		computed: {
			...mapState('user', ['userInfo', 'orderInfo', 'hasLogin'])
		},
		data() {
			return {
				// 头部图高度
				maxheight: '',
				tabCurrentIndex: 0,
				num: '',
				navList: [{
						state: 0,
						text: '支出',
						loadingType: 'more',
						orderList: [],
						page: 1, //当前页数
						limit: 10, //每次信息条数
						loaded: false
					},
					{
						state: 1,
						text: '收入',
						loadingType: 'more',
						orderList: [],
						page: 1, //当前页数
						limit: 10, //每次信息条数
						loaded: false
					},
				],
				money: '',
				userInfo: {}
			};
		},
		onLoad(options) {},
		onShow() {
			this.loadData();
			this.getUserInfo();
		},
		methods: {
			...mapMutations('user', ['setUserInfo', 'setOrderInfo']),
			getUserInfo() {
				getUserInfo({}).then(({
					data
				}) => {
					this.userInfo = data;
				});
			},
			// 页面跳转
			navto(e) {
				uni.navigateTo({
					url: e
				});
			},
			open() {
				this.$refs.popuphx.open();
			},
			close() {
				this.$refs.popuphx.close();
			},
			//获取收入支出信息
			async loadData(source) {
				//这里时将订单挂载到tab列表下
				let index = this.tabCurrentIndex;
				let navItem = this.navList[index];
				let state = navItem.state;
				if (source === 'tabChange' && navItem.loaded === true) {
					//tab切换只有第一次需要加载数据
					return;
				}
				if (navItem.loadingType === 'loading') {
					//防止重复加载
					return;
				}
				//修改当前对象状态为加载中
				navItem.loadingType = 'loading';

				integral({
						page: navItem.page,
						limit: navItem.limit,
						category: 'now_money',
						pm: state
					})
					.then(({
						data
					}) => {
						if (data.length > 0) {
							navItem.orderList = navItem.orderList.concat(data);
							navItem.page++;
						}
						//判断是否还有数据, 有改为more, 没有改为noMore
						if (navItem.limit == data.length) {
							navItem.loadingType = 'more';
							return;
						} else {
							navItem.loadingType = 'noMore';
						}
						uni.hideLoading();
						this.$set(navItem, 'loaded', true);
					})
					.catch(e => {
						console.log(e);
					});
			},

			//swiper 切换
			changeTab(e) {
				this.tabCurrentIndex = e.target.current;
				this.loadData('tabChange');
			},
			//顶部tab点击
			tabClick(index) {
				this.tabCurrentIndex = index;
			},
			addmoney() {
				uni.navigateTo({
					url: '/pages/money/recharge'
				});
			}
		}
	};
</script>

<style lang="scss">
	page {
		background-color: #fff;
		height: auto;
		min-height: 100%;
	}

	.top-bg {
		background-color: #ff4c4c;
		height: 180rpx;
		width: 750rpx;
	}

	.yue-wrap {
		width: 670rpx;
		height: 320rpx;
		margin: -160rpx auto 30rpx;
		background: linear-gradient(-70deg, #ff9265, #ff6762);
		box-shadow: 0px 15rpx 22rpx 6rpx rgba(255, 122, 99, 0.1);
		border-radius: 25rpx;
		color: #fff;
		font-size: 26rpx;
		padding: 50rpx 75rpx;
		flex-direction: column;
		justify-content: space-between;
		align-items: flex-start;

		.yue-tit {
			width: 100%;
		}

		.cz {
			image {
				width: 13rpx;
				margin-left: 10rpx;
			}
		}

		.tx {
			image {
				width: 30rpx;
				margin-right: 10rpx;
			}
		}

		.yue-num {
			width: 100%;
			justify-content: space-between;

			.yue {
				font-size: 76rpx;
				font-weight: bold;
			}

			.cz {
				image {
					width: 13rpx;
					margin-left: 10rpx;
				}
			}
		}

		.lj-wrap {
			width: 100%;
			justify-content: space-between;
			font-size: 24rpx;
		}
	}

	.swiper-box {
		.order-item:last-child {
			margin-bottom: 60rpx;
		}

		.order-item {
			padding: 20rpx 30rpx;
			line-height: 1.5;

			.title-box {
				.title {
					font-size: $font-lg;
					color: $font-color-base;
				}

				.time {
					font-size: $font-base;
					color: $font-color-light;
				}
			}

			.money {
				color: #fd5b23;
				font-size: $font-lg;
				text-align: right;

				.status {
					color: $font-color-light;
				}
			}
		}
	}

	.navbar {
		margin-top: 20rpx;
		display: flex;
		height: 88rpx;
		padding: 0 5px;
		background: #fff;
		box-shadow: 0 1px 5px rgba(0, 0, 0, 0.06);
		position: relative;
		z-index: 10;

		.nav-item {
			flex: 1;
			display: flex;
			justify-content: center;
			align-items: center;
			height: 100%;
			font-size: 15px;
			color: #999999;
			position: relative;

			&.current {
				color: #000;

				&:after {
					content: '';
					position: absolute;
					left: 50%;
					bottom: 0;
					transform: translateX(-50%);
					width: 50rpx;
					height: 6rpx;
					background: linear-gradient(90deg, #CA57DC, #65B2E9);
					border-radius: 4rpx;
				}
			}
		}
	}

	.list-scroll-content {
		background: #ffffff;
		height: 100%;
	}
</style>